var allData = [] ;
var filterData = [];
var filterSwitch = false;
var numPerPage = 8; //初始化显示场所的值
var base = numPerPage;
var comNumber = 5 ;//每次显示评论的数据
var timeoutValue = 15000;
var chatNumber = 12;
var PLATFORM_BACK_BUTTON_PRIORITY_VIEW = 100;
var PLATFORM_BACK_BUTTON_PRIORITY_SIDE_MENU = 150;
var PLATFORM_BACK_BUTTON_PRIORITY_MODAL = 200;
var PLATFORM_BACK_BUTTON_PRIORITY_ACTION_SHEET = 300;
var PLATFORM_BACK_BUTTON_PRIORITY_POPUP = 400;
var PLATFORM_BACK_BUTTON_PRIORITY_LOADING = 500;

angular.module('findit.controllers', ['ionic'])
  .controller('FindingCtrl', function($scope, $location,$ionicLoading,$state, Spots, $ionicPopover, $timeout,$rootScope,Location,$ionicHistory,$ionicPlatform,$ionicPopup) {
    $scope.closeLoader = function() {
      $ionicLoading.hide();
    };
    $scope.search = {
      string: ""
    };
    /*用户退出确认菜单*/
    $ionicPlatform.registerBackButtonAction(function (e) {
      if ($location.path() == '/tab/chat-home') {
        $rootScope.hasNewTalk = false ;
        $state.go('tab.finding');
      }else{
        if ($ionicHistory.backView()) {
          $ionicHistory.goBack();
        } else {
          var confirmPopup = $ionicPopup.confirm({
            title: '确认退出APP',
            template: "您确认要退出APP吗？",
            okText: '退出',
            cancelText: '取消'
          });
          confirmPopup.then(function (close) {
            if (close) {
              // there is no back view, so close the app instead
              ionic.Platform.exitApp();
            } // otherwise do nothing
          });
        }
      }
      e.preventDefault();
      return false;
    }, 101);

    $scope.loading = true;
    //当页面返回主页面时，需要再次显示tabs，则需要在该控制器中加上(主要是解决android上tabs还是隐藏的问题)：
    $scope.$on('$ionicView.enter', function () {
      // 显示 tabs
      $rootScope.hideTabs = false;
    });
    var map ;
    var geolocation ;
    $scope.spots = [];
    $scope.hasMore = false;
    $scope.allowRefresh = false;
    $scope.params = {
      filterSwitch : false,
      checkCategory1: true,
      checkCategory2: true,
      checkCategory3: true,
      checkCategory4: true,
      checkCategory5: true
    };

    $scope.doRefresh = function() {
      //刷新数据重置
      var partData = [];
      allData = [];
      $scope.spots = [];
      var success = false;
      $ionicLoading.show({
        templateUrl: 'templates/popover-template.html',
        scope: $scope
      });
      //$scope.loading = true;
      $timeout(function() {
        Spots.all().success(function (data, status, headers) {
          baidu_location.getCurrentPosition(function (pos){
            var geoc = new BMap.Geocoder();
            //客户点击屏蔽地址，获取城市名和大致经纬度
            if (pos.longitude == 5e-324 || pos.latitude== 5e-324) {
              function getMyCity(result){
                $rootScope.city = result.name;
                // 将地址解析结果显示在地图上,并调整地图视野
                geoc.getPoint(result.name, function(point){
                  if (point) {
                    setMainData(point.lat,point.lng, data, true);
                  }else{
                    setMainData(0,0, data, true);
                  }
                }, result.name);
              }
              var myCity = new BMap.LocalCity();
              myCity.get(getMyCity);
              $rootScope.district = "";
            } else {
              var point = new BMap.Point(pos.longitude, pos.latitude);//
              geoc.getLocation(point, function (rs) {
                var addComp = rs.addressComponents;
                //alert(addComp.province + ", " + addComp.city + ", " + addComp.district + ", " + addComp.street + ", " + addComp.streetNumber + ", 经度：" + pos.longitude + ", 纬度：" + pos.latitude);
                console.log('您的位置：' + pos.longitude + ',' + pos.latitude);
                //$scope.$apply(function(){
                $rootScope.lng = pos.longitude;
                $rootScope.lat = pos.latitude;
                $rootScope.city = addComp.city;
                $scope.province = addComp.province;
                $scope.street = addComp.street;
                $scope.city_code = addComp.city_code;
                $rootScope.district = addComp.district;
                $scope.street_number = addComp.street_number;
                success = true;
                setMainData(pos.latitude, pos.longitude, data, true);
                filterSwitch = false;
                $scope.params.filterSwitch = false; //恢复toggle为false
                base = numPerPage;//release loadmore
              });
            }
          }, function (error){
            setMainData(0, 0, data, false);
          });

        }).error(function (data, status, headers) {
          $ionicLoading.show({template: "似乎是网络不通，请再使劲下拉列表刷新一下...", noBackdrop: true, duration: 2000});
          //$scope.loading = false;
        }) .finally(function () {
          // Stop the ion-refresher from spinning
          $scope.$broadcast('scroll.refreshComplete');
          //$scope.loading = false;
          $ionicLoading.hide();
        })
      },2000);

      function setMainData(lat, lng, data, isSucceed) {
        allData = findItApp.getOrderedData(data,lat, lng,allData.length==0?false:true);
        if (!isSucceed) {$ionicLoading.show({template: "获取位置失败，可能原因：(1)网络不通 (2)您拒绝了app的位置访问权限", noBackdrop: true, duration: 2500});}
        for(var i=0;i<numPerPage;i++)
        {
          partData[i] = allData[i];
        }
        $scope.$apply(function() {
          $scope.spots = partData;
          $scope.hasMore = true; //release loadmore
        });
      };
    };

    //程序入口
    Location.ready().then(rootCallback, rootCallback);
    var partData = [];
    function rootCallback(){
      Spots.all().success(function(data,status,headers){
        $scope.allowRefresh = true; //allow refresh
        $scope.loading = true;

        // 进行定位
        baidu_location.getCurrentPosition(function (pos){
          var geoc = new BMap.Geocoder();
          //客户点击屏蔽地址，获取城市名和大致经纬度
          if (pos.longitude == 5e-324 || pos.latitude== 5e-324) {
            function getMyCity(result){
              $rootScope.city = result.name;
              // 将地址解析结果显示在地图上,并调整地图视野
              geoc.getPoint(result.name, function(point){
                if (point) {
                  setMainData(point.lat,point.lng, data, true);
                }else{
                  setMainData(0,0, data, true);
                }
              }, result.name);
            }
            var myCity = new BMap.LocalCity();
            myCity.get(getMyCity);
            $rootScope.district = "";
          } else {
            var point = new BMap.Point(pos.longitude, pos.latitude);//
            geoc.getLocation(point, function(rs){
              var addComp = rs.addressComponents;
              //alert(addComp.province + ", " + addComp.city + ", " + addComp.district + ", " + addComp.street + ", " + addComp.streetNumber + ", 经度：" + pos.longitude + ", 纬度：" + pos.latitude);
              $rootScope.city = addComp.city;
              $scope.province = addComp.province;
              $scope.street = addComp.street;
              $scope.city_code = addComp.city_code;
              $rootScope.district = addComp.district;
              $scope.street_number = addComp.street_number;
              $scope.$apply(function(){
                $rootScope.lng = pos.longitude;
                $rootScope.lat = pos.latitude;
              });
              setMainData(pos.latitude, pos.longitude,data, true);
            });
          }
        }, function (error){
          setMainData(0,0, data, false);
        });
      }).error(function(data, status, headers) {
        $ionicLoading.show({template:"似乎是网络不通，请再使劲下拉列表刷新一下...", noBackdrop: true, duration: 2000});
        $scope.loading = false;
      });
    };
    function setMainData(lat, lng, data, isSucceed) {
      allData = findItApp.getOrderedData(data,lat, lng, false);
      if (!isSucceed) {$ionicLoading.show({ template: "获取位置失败，使劲下拉一下列表然后等等看...", noBackdrop: true, duration: 2500 });}
      $scope.loading = false;
      for(var i=0;i<numPerPage;i++)
      {
        partData[i] = allData[i];
      }
      $scope.$apply(function() {
        $scope.spots = partData;
        $scope.hasMore = true ;
      });
    };

    $scope.loadMore = function(){
      $timeout(function(){
        if(filterSwitch){
          console.log("base..." + base + " length:" + filterData.length);
          for(var i=0;i<numPerPage;i++,base++) {
            if (base > filterData.length - 1){
              console.log("load more ends..");
              $scope.hasMore = false;
            } else {
              console.log("push data and load more and more...");
              $scope.spots.push(filterData[base]);
            }
          }
        } else{
          console.log("base..." + base + " length:" + allData.length);
          for(var i=0;i<numPerPage;i++,base++) {
            if (base > allData.length - 1){
              console.log("load more ends..");
              $scope.hasMore = false;
            } else {
              console.log("push data and load more and more...");
              $scope.spots.push(allData[base]);
            }
          }
        }
        $scope.$broadcast('scroll.infiniteScrollComplete');
      },1000);
    };
    //popover实现开始
    $scope.popover = $ionicPopover.fromTemplateUrl('my-popover.html', {
      scope: $scope
    });
    // .fromTemplateUrl() 方法
    $ionicPopover.fromTemplateUrl('my-popover.html', {
      scope: $scope
    }).then(function(popover) {
      $scope.popover = popover;
    });
    $scope.openPopover = function($event) {
      $scope.popover.show($event);
    };
    $scope.closePopover = function() {
      $scope.popover.hide();
    };
    // 清除浮动框
    $scope.$on('$destroy', function() {
      $scope.popover.remove();
    });
    // 在隐藏浮动框后执行
    $scope.$on('popover.hidden', function() {
      // 执行代码
    });
    // 移除浮动框后执行
    $scope.$on('popover.removed', function() {
      // 执行代码
    });

    $scope.$watch('params.filterSwitch', function(newValue, oldValue) {
      $scope.filterSwitch = !$scope.filterSwitch;
    },true);

    $scope.$watch('params.checkCategory1', function(newValue, oldValue) {
      $scope.checkCategory1 = !$scope.checkCategory1;
    },true);

    $scope.$watch('params.checkCategory2', function(newValue, oldValue) {
      $scope.checkCategory2 = !$scope.checkCategory2;
    },true);

    $scope.$watch('params.checkCategory3', function(newValue, oldValue) {
      $scope.checkCategory3 = !$scope.checkCategory3;
    },true);

    $scope.$watch('params.checkCategory4', function(newValue, oldValue) {
      $scope.checkCategory4 = !$scope.checkCategory4;
    },true);

    $scope.$watch('params.checkCategory5', function(newValue, oldValue) {
      $scope.checkCategory5 = !$scope.checkCategory5;
    },true);

    $scope.changeCategory = function (params) {
      $scope.closePopover();//关闭窗口
      if (params.filterSwitch) {
        filterSwitch = true;
      } else {
        filterSwitch = false;
      }

      if(!filterSwitch){
        filterSwitch = false;
        var partData = [];
        for(var i=0;i<numPerPage;i++)
        {
          partData[i] = allData[i];
        }
        $scope.spots = partData;
        $scope.hasMore = true; //release loadmore
        base = numPerPage;//release loadmore
        return ;
      }
      if (params.checkCategory1) {
        params.checkCategory1 = true;
      } else {
        params.checkCategory1 = false;
      }

      if (params.checkCategory2) {
        params.checkCategory2 = true;
      } else {
        params.checkCategory2 = false;
      }

      if (params.checkCategory3) {
        params.checkCategory3 = true;
      } else {
        params.checkCategory3 = false;
      }

      if (params.checkCategory4) {
        params.checkCategory4 = true;
      } else {
        params.checkCategory4 = false;
      }

      if (params.checkCategory5) {
        params.checkCategory5 = true;
      } else {
        params.checkCategory5 = false;
      }

      //数据筛选器
      filterData = [];
      angular.forEach(allData, function(item) {
        if (item.category.indexOf("1")!=-1)
        {
          if (params.checkCategory1)
          {
            this.push(item);
          }
        }
        else if (item.category.indexOf("2")!=-1)
        {
          if (params.checkCategory2)
          {
            this.push(item);
          }
        }
        else if (item.category.indexOf("3")!=-1)
        {
          if (params.checkCategory3)
          {
            this.push(item);
          }
        }
        else if (item.category.indexOf("4")!=-1)
        {
          if (params.checkCategory4)
          {
            this.push(item);
          }
        }
        else if (item.category.indexOf("5")!=-1)
        {
          if (params.checkCategory5)
          {
            this.push(item);
          }
        }
      }, filterData);

      var partData = [];
      for (var i = 0; i < numPerPage; i++) {
        if (filterData[i] != undefined){
          partData[i] = filterData[i];
        }
      }
      filterSwitch = true;
      $scope.spots = partData;
      $scope.hasMore = true; //release loadmore
      base = numPerPage;//release loadmore
    };

  })

  .controller('ArticleCtrl', function($scope,Articles,$ionicLoading,$rootScope) {
    $scope.closeLoader = function() {
      $ionicLoading.hide();
    };
    $scope.openWebsite = function(){
      window.open('http://58boy.com', '_system', 'location=yes');
    }

    $scope.$on('$ionicView.enter', function () {
      // 显示 tabs
      $rootScope.hideTabs = false;
    });

    var partData = [];
    $scope.hasMore = false;
    var page = 1 ;
    var isSearchPage = false;
    var searchKeywords = "";
    $scope.loading = true;
    Articles.all(page, function(items) {
      $scope.items = items.data.posts;
      $scope.hasMore = true;
    }, function(error) {
      //alert("似乎是网络不通，请尝试在有网环境下使用此APP");
      $ionicLoading.show({template:"系统繁忙,轻稍等一下点左上角刷新图标...", noBackdrop: true, duration: 2000});
    }, function(){
      $scope.loading = false;
    });

    $scope.searchArt = function(keywords){
      if(keywords == undefined || keywords == ''){
        $ionicLoading.show({template:"请输入关键字...", noBackdrop: true, duration: 2000});
        return ;
      }
      page = 1 ; //page回归1
      isSearchPage = true;
      searchKeywords = keywords;
      //$scope.cancel = $ionicLoading.hide; //https://forum.ionicframework.com/t/ionicloading-is-there-a-way-to-cancel-loading/2939
      $rootScope.cancel = $ionicLoading.hide;
      $ionicLoading.show({
        templateUrl: 'templates/popover-template.html',
        scope: $scope
      });
      Articles.search(keywords, page, function (items) {
        $scope.items = items.data.posts;
        $scope.hasMore = true;
      }, function(){
        $ionicLoading.hide();
      });
    };

    $scope.loadMore = function(){
      page++;
      console.log("page:" + page);
      console.log("isSearchPage:" + isSearchPage);
      //$scope.hasMore = false;
      if(isSearchPage){
        Articles.search(searchKeywords, page, function (items) {
          if (items.data.count == 0) {
            $scope.hasMore = false;
          }else {
            $scope.items = $scope.items.concat(items.data.posts);
          }
          $scope.$broadcast('scroll.infiniteScrollComplete');
          //$scope.hasMore = true;
        });
      } else {
        Articles.all(page, function (items) {
          if (items.data.count == 0) {
            $scope.hasMore = false;
          }else{
            $scope.items = $scope.items.concat(items.data.posts);
          }
          $scope.$broadcast('scroll.infiniteScrollComplete');
          //$scope.hasMore = true;
        });
      }
    };

    $scope.getDateDiff = function(dateTime){
      return findItApp.getDateDiff(Date.parse(dateTime));
    };

    $scope.refreshArticles = function(){
      if (!$scope.loading){
        //$scope.loading = true;
        $ionicLoading.show({
          templateUrl: 'templates/popover-template.html',
          scope: $scope
        });
        //$scope.items = [];
        page = 1;
        isSearchPage = false;
        Articles.all(page, function(items) {
          console.log("items:" + items);
          $scope.items = items.data.posts;
          $scope.hasMore = true;
        },null, function(){
          $ionicLoading.hide();
          //$scope.loading = false;
        });
      }
    };
  })

  .controller('SpotMapCtrl', function($scope,$stateParams) {
    for (var i = 0; i < allData.length; i++) {
      if (allData[i].id == $stateParams.spotId){
        $scope.typeId = $stateParams.typeId;
        if ($stateParams.typeId == 1) {
          $scope.title = "去" + allData[i].officialName + "公交路线图";
        }else{
          $scope.title = "去" + allData[i].officialName + "自驾路线图";
        }
        $scope.spot = allData[i];
      }
    }
  })

  .controller('SpotDetailCtrl', function($scope, $ionicActionSheet, $stateParams,$rootScope,$ionicScrollDelegate,ls,ss,Spots,$ionicLoading,$ionicSlideBoxDelegate,$timeout) {
    var ref = new Wilddog(findItApp.saasServer);
    ref.onAuth(authDataCallback);
    var isLogin ;
    var userKey ;
    var orderBy = "timeStamp";
    $scope.bigImage = false;    //初始默认大图是隐藏的

    function authDataCallback(authData) {
      if (authData) {
        //正常登录
        if (authData.provider != "anonymous") {
          isLogin = true;
          userKey = authData.uid.replace("simplelogin:","");
          var ref2 = new Wilddog(findItApp.saasServer + "user/" + userKey);
          ref2.once("value", function(snapshot,error) {
            if (error == null) {
              ls.set("mySpotLike",snapshot.val().spotlike);
            }
          });
        }
      }
    }

      var spotData ;
      $scope.mainLoading = true;
      //读取detail信息
      spotData = findItApp.setSpotDetail(allData,$stateParams.spotId);
      Spots.one(spotData.key).success(function (data, status, headers) {
        //findItApp.replaceAll(allData[i].category);
        spotData.picsArr = data.images.split('|');
        spotData.like = data.like;
        spotData.link = data.link;
        spotData.officehours = data.officehours;
        spotData.remark = data.remark;
        spotData.tagsArr = data.tags.split('|');
        spotData.telesArr = data.telephone.split('|');
        spotData.ticketprice = data.ticketprice;
        spotData.transport = data.transport;
        spotData.website = data.website;

        $scope.spot = spotData;
        $ionicSlideBoxDelegate.update();
        $scope.mainLoading = false;
        $scope.comLoading = true;
        //console.log(ls.get($scope.spot.key));
        if (ls.get($scope.spot.key) == undefined || ls.get($scope.spot.key) == "false"){
          $scope.button = {
            class:"button button-assertive",
            value:"赞这里",
            active: true
          };
        } else {
          $scope.button = {
            class:"button button-stable",
            value:"取消赞",
            active: false
          };
        }
        
        //显示评论部分，读取数据库数据
        //https://wild-cock-9163.wilddogio.com/comment/1.json?orderBy="$key"&limitToLast=3
        var ref = new Wilddog(findItApp.saasServer + "comment/" + spotData.key);
        ref.orderByKey().limitToLast(comNumber).on("value", function(snapshot) {
            $scope.comLoading = false;
            $scope.comments = findItApp.getCommentsContent(snapshot.val());
            $scope.commentsNum = $scope.comments.length;
            if(!$scope.$$phase) {
              $scope.$digest();
            }
        });
      }).error(function (data, status, headers) {
        $ionicLoading.show({template: "似乎是网络不通，退出再进一下吧...", noBackdrop: true, duration: 2000});
      }) .finally(function () {
        $scope.mainLoading = false;
        $scope.comLoading = false;
        if(!$scope.$$phase) {
          $scope.$digest();
        }
      });

    $scope.spotlike = function (flag){
      if (isLogin){
        if(flag){ //想收藏
          //if(ls.get("mySpotLike") == undefined){
          //  ls.set("mySpotLike", "(" + $scope.spot.key + ")");
          //}else{
            var spotlikeArr = ls.get("mySpotLike")==undefined?"":ls.get("mySpotLike");
            spotlikeArr += "(" + $scope.spot.key + ")";
            ls.set("mySpotLike", spotlikeArr);
            findItApp.updateSpot(userKey,spotlikeArr);
          //}
          console.log(ls.get("mySpotLike"));
          $ionicLoading.show({template:"收藏成功，可在'我的'-'我的收藏'中查看...", noBackdrop: true, duration: 1000});
        } else { //已经收藏，又不想收藏了
          var spotlikeStr = ls.get("mySpotLike");
          var reg=new RegExp("\\(" + $scope.spot.key + "\\)","g");
          spotlikeStr = spotlikeStr.replace(reg, '');
          ls.set("mySpotLike", spotlikeStr);
          findItApp.updateSpot(userKey,spotlikeStr);
          $ionicLoading.show({template:"取消收藏成功...", noBackdrop: true, duration: 1000});
        }
      } else {
        $ionicLoading.show({template:"只有会员才能收藏，请点击“我的”注册会员...", noBackdrop: true, duration: 2000});
      }
    };

    $scope.spotLikeOrNot = function(){
      var spotlikeArr = ls.get("mySpotLike");
      if (spotlikeArr != undefined){
        if (spotlikeArr.indexOf("(" + $scope.spot.key + ")") > -1){
          return true;
        }
        return false;
      } else {
        return false;
      }
    }

    $scope.openLink = function(url){
      window.open(url, '_blank', 'location=yes');
    };

    $scope.likeIt = function(s) {
      console.log($scope.spot.key);
      var ref = new Wilddog(findItApp.saasServer + "spotdetail").child($scope.spot.key);
      if(s){
        $scope.button.class = "button button-stable";
        $scope.button.value = "取消赞";
        $scope.button.active = false;
        //like+1
        ref.update({
          "like": $scope.spot.like + 1
        });
        $scope.spot.like ++ ;
        ls.set($scope.spot.key, true);
      } else {
        $scope.button.class = "button button-assertive";
        $scope.button.value = "赞这里";
        $scope.button.active = true;
        ref.update({
          "like": $scope.spot.like - 1
        });
        $scope.spot.like -- ;
        ls.set($scope.spot.key, false);

      }
    };
    $scope.getDateDiff = function(timeStamp){
      return findItApp.getDateDiff(timeStamp);
    };

    $scope.goToComment = function(route){
      //是否禁言开始
      var ipAddr = ss.get("myIp");
      if (ipAddr == undefined ){
        ipAddr = "0.0.0.0";
      }
      var cityAddr = $rootScope.city == undefined ? "火星" : $rootScope.city;
      findItApp.yourMutedOrNot(ipAddr, cityAddr, function (exists){
        if (exists) {
          alert ("抱歉！您被禁止吐槽，请遵守各项法规，解禁后再来发言！");
        } else {
          window.location.href='#/tab/'+route+'/comment/'+$scope.spot.id + "/" + $scope.spot.key;
        }
      });
      //是否禁言结束
    };

    $scope.viewMoreComments = function(count){
      $scope.comLoading = true;
      var ref = new Wilddog(findItApp.saasServer + "comment/" + spotData.key);
      if (orderBy == "timeStamp") {
        ref.orderByKey().limitToLast(comNumber + count).on("value", function(snapshot) {
          $scope.comLoading = false;
          $scope.comments = findItApp.getCommentsContent(snapshot.val());
          $scope.commentsNum = $scope.comments.length;
          console.log("数目："+ $scope.commentsNum);
          if ($scope.commentsNum < comNumber + count){
            console.log("没有更多评论了");
            $scope.comNomore = true;
          }
          if(!$scope.$$phase) {
            $scope.$digest();
          }
        });
      } else {
        ref.orderByChild("like").limitToLast(comNumber + count).on("value", function(snapshot) {
          $scope.comLoading = false;
          $scope.comments = findItApp.getCommentsContent(snapshot.val());
          $scope.commentsNum = $scope.comments.length;
          console.log("数目："+ $scope.commentsNum);
          if ($scope.commentsNum < comNumber + count){
            console.log("没有更多评论了");
            $scope.comNomore = true;
          }
          if(!$scope.$$phase) {
            $scope.$digest();
          }
        });
      }
    };

    $scope.showLike = function(key){
      if (ss.get(key) == undefined || ss.get(key) == "false"){
        return true;
      } else {
        return false;
      }
    };
    $scope.likeThisComment = function(s,key,likeNum){
      var ref = new Wilddog("https://wild-cock-9163.wilddogio.com/comment/" + $scope.spot.key);
      var comRef = ref.child(key);
      if(s){
        comRef.update({
          "like": likeNum + 1
        });
        ss.set(key, true);
      } else {
        comRef.update({
          "like": likeNum - 1
        });
        ss.set(key, false);
      }
    };

    $scope.commentStatus = function(){
      if (orderBy=='timeStamp'){
        return false;
      }
      return true;
    }
    $scope.commentorderby = function(number){
      $scope.comLoading = true;
      $scope.comments = "";
      $timeout(function() {
          var ref = new Wilddog("https://wild-cock-9163.wilddogio.com/comment/" + $scope.spot.key);
          if (number == 1){
            orderBy = "timeStamp";
            ref.orderByKey().limitToLast(comNumber).on("value", function(snapshot) {
                $scope.comLoading = false;
                $scope.comments = findItApp.getCommentsContent(snapshot.val());
                $scope.commentsNum = $scope.comments.length;
                if(!$scope.$$phase) {
                  $scope.$digest();
                }
            });
          } else {
            orderBy = "rate";
            ref.orderByChild("like").limitToLast(comNumber).on("value", function(snapshot) {
                $scope.comLoading = false;
                $scope.comments = findItApp.getCommentsContent(snapshot.val());
                $scope.commentsNum = $scope.comments.length;
                if(!$scope.$$phase) {
                  $scope.$digest();
                }
            });
          }
      }, 2000);
    }

    $scope.showBigImage = function (imageName) {  
      $scope.imageUrl = imageName;   
      $scope.bigImage = true; 
    }

    $scope.hideBigImage = function () {
        $scope.bigImage = false;
    }

  })

  .controller('SpotLocationCtrl', function($scope,$stateParams) {
    for (var i = 0; i < allData.length; i++) {
      if (allData[i].id == $stateParams.spotId){
        $scope.spot = allData[i];
      }
    }
  })
  .controller('SpotCommentCtrl', function($scope,$rootScope,$stateParams,$ionicLoading,ls,ss,Private) {
    //for (var i = 0; i < allData.length; i++) {
    //  if (allData[i].id == $stateParams.spotId){
    //    $scope.spot = allData[i];
    //  }
    //}
    $scope.keyId = $stateParams.keyId;
    $scope.comment = {
      level:0,
      text : ""
    };
    $scope.leaveWords = function(route){
      //alert($scope.comment.level);
      var comment = findItApp.stripscript($scope.comment.text);
      if (comment.length <= 5 || comment.length >= 400){
        $ionicLoading.show({ template: "您的发言字数应在5-400汉字之间。", noBackdrop: false, duration: 2000 });
        return ;
      }

      if (findItApp.hasBadWords(comment,$rootScope.badwords)) {
        $ionicLoading.show({ template: "发言中有不雅及广告词汇，请纠正后再发。", noBackdrop: false, duration: 2000 });
        return ;
      }

      var cityName,ipAddr,nickName,timeStamp;
      timeStamp=new Date().getTime();

      if (ss.get("myIp") == undefined || ls.get("myNickName") == undefined){
        console.log("Getting the city and ip data...");
        if (ls.get("myNickName") == undefined){
          //昵称获取
          var randomNumber = Math.floor(Math.random() * ( findItApp.nickNames.length));
          ls.set("myNickName", findItApp.nickNames[randomNumber]);
        }

        //IP获取
        Private.ip(function(params){
          ipAddr = params.data.ip;
          if (cityName != null && cityName != ""){
            ss.set("myIp", ipAddr);
          }

          //创建留言数据库
          var ref = new Wilddog(findItApp.saasServer + "comment/"+ $scope.keyId + "/" + timeStamp);
          ref.set({
            "author" : $rootScope.city + "|" + ls.get("myNickName") + "|" + ipAddr + "|" + $scope.comment.level ,
            "comment" : $scope.comment.text,
            "like" : 0,
            "parentId": 0
          });
        });
      } else {
        console.log("Got the city and ip data from session...");
        //创建留言数据库
        var ref = new Wilddog(findItApp.saasServer + "comment/"+ $scope.keyId + "/" + timeStamp);
        ref.set({
          "author" : $rootScope.city + "|" + ls.get("myNickName") + "|" + ss.get("myIp") + "|" + $scope.comment.level ,
          "comment" : $scope.comment.text,
          "like" : 0,
          "parentId": 0
        });
      }
      $ionicLoading.show({ template: "谢谢您参与评论，返回页面后就可以看到咯...", noBackdrop: false, duration: 2500 });
      window.location.href="#/tab/" + route+ "/" +$stateParams.spotId ;
    };
  })
  .controller('ArticleDetailCtrl', function($scope,$rootScope,$stateParams,Articles,$ionicLoading,$ionicActionSheet,$ionicScrollDelegate,$sce) {
    $scope.closeLoader = function() {
      $ionicLoading.hide();
    };
    $scope.goToPage = function (url) {
      window.open(url, '_blank', 'location=yes');
    };

    //$scope.cancel = $ionicLoading.hide;
    $rootScope.cancel = $ionicLoading.hide;
    $ionicLoading.show({
      templateUrl: 'templates/popover-template.html',
      scope: $scope
    });
    $scope.id = $stateParams.articleId;
    Articles.detail($stateParams.articleId, function (item) {
      $scope.item = item.data.post;
      $scope.item.previous_url = findItApp.replaceUrl(item.data.previous_url);
      $scope.item.next_url = findItApp.replaceUrl(item.data.next_url);
      $scope.sanitized = $sce.trustAsHtml(findItApp.replaceUrlLink($scope.item.content));
    }, function(){
      $ionicLoading.hide();
    });

    $scope.scrollTop = function () {
      $ionicScrollDelegate.scrollTop();
    };

    $scope.openLink = function(url){
      //window.open(url, '_system', 'location=yes');
      window.open(url, '_blank', 'location=yes');
    };
  })
  .controller('SettingCtrl', function($scope,$rootScope,$ionicPopup,$ionicLoading,ls) {
    $scope.nickname = ls.get("myNickName")==undefined?"无名氏":ls.get("myNickName");
    $scope.checkLatestVer = function () {
      if ($rootScope.hasNewVer){
        //不是最新版本，要下载最新版本
        var confirmPopup = $ionicPopup.confirm({
          title: '有新版的版本',
          template: '你确定你要下载最新版本ver ' + $rootScope.latestVer + "吗？",
          okText: '确定',
          cancelText: '取消'
        });
        confirmPopup.then(function(res){
          if (res){
            window.open("http://app.58boy.com/findit_v" + $rootScope.latestVer + ".apk", '_system', 'location=yes');
          }
        });
      } else if ($rootScope.hasNewVer == undefined) {
        $ionicLoading.show({ template: "系统繁忙，请稍后再试...", noBackdrop: true, duration: 2500 });
      }else {
        //已经是最新版本了
        $ionicLoading.show({ template: "您现在用的已经是最新版本了", noBackdrop: true, duration: 2500 });
      }
    };
    $scope.openQQ = function(qunhao){
      window.open('mqqapi://card/show_pslcard?src_type=internal&version=1&uin=' + qunhao + '&card_type=group&source=qrcode', '_system', 'location=yes');
    }
  })
  .controller('ProfileCtrl', function($scope,$rootScope,$ionicPopup,$ionicLoading,ls,$ionicActionSheet,$timeout,$cordovaEmailComposer) {
    $scope.closeLoader = function() {
      $ionicLoading.hide();
    };
    $scope.$on('$ionicView.enter', function () {
      // 显示 tabs
      $rootScope.hideTabs = false;
    });

    var ref = new Wilddog(findItApp.saasServer);
    ref.onAuth(authDataCallback);

    function authDataCallback(authData) {
      if (authData) {
        $scope.userId = authData.uid;
        if(authData.provider == "anonymous"){ //匿名登录
          $scope.thumb = "http://app.58boy.com/userthumb/none.png";
          $scope.state = "anonymous";
          $scope.name = "匿名用户";
        } else { //正常登陆
          //$ionicLoading.show({template:'<ion-spinner icon="ios-small"></ion-spinner><br/>加载中...<span style="line-height: normal" ng-click="$root.cancel()"><i style="font-size: 30px;" class="icon ion-close-circled"></i></span>',noBackdrop:false, hideOnStateChange:true,  scope: $scope});
          $ionicLoading.show({
            templateUrl: 'templates/popover-template.html',
            scope: $scope
          });
          $scope.state = "simplelogin";
          $scope.key = authData.uid.replace("simplelogin:","");
          var ref2 = new Wilddog(findItApp.saasServer + "user/" + $scope.key);
          ref2.on("value", function(snapshot,error) {
            if (error == null) {
              $scope.city = $rootScope.city==undefined?snapshot.val().city:$rootScope.city;
              $scope.name = snapshot.val().name;
              $scope.phone = snapshot.val().phone;
              $scope.thumb = findItApp.thumbConvert(snapshot.val().thumb);
            }
            $ionicLoading.hide();
          });
          ref2.update({
            "logtime": findItApp.getTime(new Date())
          });
        }
      } else {
        console.log("没有登录");
        $scope.name = "未登录";
        $scope.state = "none";
      }
    };

    $scope.showActionsheet = function(){
      if ($scope.state == "anonymous") {
        alert("匿名用户不能上传头像，建议注销后注册会员！");
        return ;
      }

      $ionicActionSheet.show({
        titleText : '更换头像',
        cancelText: '取消',
        buttons   : [{text:'从相册中选取'},{text:'拍照'}],
        cancel: function() {
          // add cancel code..
        },
        buttonClicked : function(index){
          switch(index){
            case  1:navigator.camera.getPicture(cameraSuccess, cameraError, {
              quality: 100, targetWidth: 150, targetHeight: 150, destinationType: navigator.camera.DestinationType.FILE_URI,sourceType: 1
            });break;
            case  0:
            default:navigator.camera.getPicture(cameraSuccess, cameraError, {
              quality: 100, targetWidth: 150, targetHeight: 150, destinationType: navigator.camera.DestinationType.FILE_URI,sourceType: index
            }); break;
          }
          return true;
        }
      });
    };

    function cameraSuccess(img) {
      $scope.img = img;//这里返回的img是选择的图片的地址，可以直接赋给img标签的src，就能显示了

      window.resolveLocalFileSystemURL(img, function success(fileEntry) {
        //alert("成功:" + fileEntry.toURL() + "img:" + img);
        $ionicLoading.show({
          templateUrl: 'templates/popover-template.html',
          scope: $scope
        });
        upload(fileEntry.toURL());//将获取的文件地址转换成file transfer插件需要的绝对地址 以前是toInternalURL（）

      }, function() {
        alert("转换成本地图片地址错误，重试一下吧！");
      });
    }
    function cameraError(img) {
      //用户取消
    }

    // 显示上传进度，不知道为何不起作用，待定
    function showUploadingProgress( progressEvt ){
      if( progressEvt.lengthComputable ){
        navigator.notification.progressValue( Math.round( ( progressEvt.loaded / progressEvt.total ) * 100) );
      }
    }

    function upload(fileURL) {//上传图片
        var win = function(r) {//成功回调方法
          //alert(r.response);
          var response = JSON.parse(r.response);//你的上传接口返回的数据
          $ionicLoading.hide();
          if(response.status){ //自己定义response的json格式在http://app2.58boy.com/appuploadthumb/examples/upload.php里
            //头像更新步骤，更新user里的thumb字段，同时可以查看最新的图片在 https://portal.qiniu.com/bucket/e263/resource 中
            //缩略图写法在http://developer.qiniu.com/code/v6/api/kodo-api/obsolete/imageview.html#imageView-samples
            //server端案例在 https://github.com/brycecurtis/articles/tree/master/CameraUpload/Server
            var ref = new Wilddog(findItApp.saasServer +  "user/" + $scope.key);
            ref.update({
              "thumb" : findItApp.fileServer + findItApp.qiniuNameFilter(response.info.key)
            });
          }else {
            alert(response.error);
          }
        }

        var fail = function(error) {//失败回调方法
          alert("系统繁忙，请选择其它图片或者过会再传，不好意思，抱歉！"); // JSON.stringify(error)
          $ionicLoading.hide();
        }

        var options = new FileUploadOptions();
        options.fileKey = "pic";//这是你的上传接口的文件标识，服务器通过这个标识获取文件
        options.key = "e263";
        options.fileName = fileURL.substr(fileURL.lastIndexOf('/') + 1);
        options.mimeType = "image/jpeg";//图片
        options.chunkedMode = false;
        options.timeout = 8000;

        var ft = new FileTransfer();
        //ft.onprogress = showUploadingProgress;
        //navigator.notification.progressStart("", "当前上传进度");
        ft.upload(fileURL, encodeURI('http://app2.58boy.com/appuploadthumb/examples/upload.php'), win, fail, options);//开始上传，uoloadurl是你的上传接口地址;
    };

    $scope.changeNickName = function() {
      var randomNumber = Math.floor(Math.random() * ( findItApp.nickNames.length));
      ls.set("myNickName", findItApp.nickNames[randomNumber]);
      $scope.nickname = ls.get("myNickName");
      alert("评论名更换为：" + $scope.nickname + "\n该名称只显示在场所评论中");
    };
    $scope.nickname = ls.get("myNickName")==undefined?"无名氏":ls.get("myNickName");
    $scope.quitAccount = function() {
      var ref = new Wilddog(findItApp.saasServer);
      var authData = ref.getAuth();
      if (authData) {
        var confirmPopup = $ionicPopup.confirm({
          title: '确认注销',
          template: "您确认要注销登录帐号吗？",
          okText: '注销',
          cancelText: '取消'
        });
        confirmPopup.then(function (close) {
          if (close) {
            ref.unauth();
            $ionicLoading.show({ template: "注销账号成功...", noBackdrop: true, duration: 2500 });
          } // otherwise do nothing
        });
      } else {
        $ionicLoading.show({ template: "您没登录，所以不用注销哦...", noBackdrop: true, duration: 2500 });
      }
      //ionic.Platform.exitApp();
    };
    $scope.goToSettingPage = function() {
      window.location.href='#/tab/setting';
    };

    $scope.emailUs = function () {
      $cordovaEmailComposer.isAvailable().then(function() {
        var email = {
          to: '13426390601@163.com',
          cc: '',
          bcc: [],
          attachments: [],
          subject: '有商家入驻或好场所推荐',
          body: '请写下您所在的酒吧/浴室/据点的详细地址,简介和均价和店主联系方式(如有),并在附件里附上几张照片，信息不全不予采纳'
        };

        $cordovaEmailComposer.open(email).then(null, function () {
          //alert('Email cancelled');
        });
      }, function () {
        alert('您没装邮件客户端，如果联系请记住邮件:13426390601@163.com');
      });
    };
  })
  .controller('ProfileUpdateCtrl',function($scope,$stateParams,$state,$rootScope,$ionicLoading){
    $scope.usr= {
      key: $stateParams.keyId,
      city:$stateParams.city,
      name: $stateParams.name,
      phone:$stateParams.phone,
    };

    $scope.warnInfo = function(){
      alert("位置信息不允许更改！");
    };

    $scope.saveUser = function(){
      console.log($scope.usr);
      if($scope.usr.phone == undefined){
        $ionicLoading.show({ template: "您的手机号码位数或格式不对，请检查...", noBackdrop: true, duration: 2000 });
        return ;
      }
      if($scope.usr.name == undefined){
        $ionicLoading.show({ template: "您的昵称应该保持2-15位，且只能为中文、字母、数字和下划线，请检查...", noBackdrop: true, duration: 2000 });
        return;
      }

      var ref = new Wilddog(findItApp.saasServer + "user/"+ $scope.usr.key);
      ref.update({
        "city" :  $scope.usr.city ,
        "name": $scope.usr.name,
        "phone" : $scope.usr.phone
      });
      $state.go('tab.profile');
      $ionicLoading.show({ template: "个人资料更新成功...", noBackdrop: true, duration: 1000 });
    };
  })
  .controller( 'SettingHowtoCtrl',function($scope,Information,$sce){
    Information.howto(function (params) {
      $scope.content = params.data;
    });
  })
  .controller( 'SpotImageCtrl',function($scope,$stateParams){
    for (var i = 0; i < allData.length; i++) {
      if (allData[i].id == $stateParams.spotId){
        $scope.officialName = allData[i].officialName;
        $scope.pics = allData[i].pics;
      }
    }
  })

  .controller( 'SettingFeedCtrl', function($scope,$rootScope,$ionicLoading,ss){
    $scope.comment = {
      text : ""
    };
    $scope.leaveWords = function(){
      var comment = findItApp.stripscript($scope.comment.text);
      if (comment.length <= 5 || comment.length >= 400){
        $ionicLoading.show({ template: "您的留言字数应在5-400汉字之间。", noBackdrop: false, duration: 2000 });
        return ;
      }

      if (findItApp.hasBadWords(comment,$rootScope.badwords)) {
        $ionicLoading.show({ template: "发言中有不雅及广告词汇，请纠正后再发。", noBackdrop: false, duration: 2000 });
        return ;
      }
      var cityName,ipAddr,timestamp;
      timestamp = new Date().getTime();
      console.log("Got the city and ip data from session...");
      var ref = new Wilddog(findItApp.saasServer + "feedback/"+ timestamp);
      ref.set({
        "city" : $rootScope.city==undefined?"火星":$rootScope.city ,
        "ip":ss.get("myIp"),
        "content" : $scope.comment.text
      });
      $ionicLoading.show({ template: "谢谢您参与反馈意见，您的意见将是我们改进APP的最大动力!", noBackdrop: true, duration: 2000 });
      window.location.href="#/tab/profile" ;
    };
  })

  .controller( 'SpotFavoriteCtrl',function($scope,ls,$state){
    //返回总消失，这个是加入让他固定在左上角，返回主页
    $scope.$on('$ionicView.beforeEnter', function (event, viewData) {
      viewData.enableBack = false;
    });
    $scope.goToProfile = function(){
      $state.go('tab.profile');
    };
    //返回功能结束
    var favoriteData = [];
    var spotlikeArr = ls.get("mySpotLike");
    //alert("spotlikeArr:" + spotlikeArr);
    if (spotlikeArr == undefined || spotlikeArr.length==0) {
      $scope.noSpotChecked = true;
    } else {
      var index = 0;
      for(var i=0;i<allData.length;i++){
        if(spotlikeArr.indexOf("(" + allData[i].key + ")") > -1){
          favoriteData[index] = allData[i];
          index++;
        }
      }
      $scope.spots = favoriteData;
    }
  })
  .controller( 'ChatLogCtrl',function($scope,ls, $state,$ionicLoading,$rootScope,$ionicPopup,Information){
    $scope.closeLoader = function() {
      $ionicLoading.hide();
    };
    $scope.user = {
      username: "",
      password:""
    };
    //当页面返回主页面时，需要再次显示tabs，则需要在该控制器中加上(主要是解决android上tabs还是隐藏的问题)：
    $scope.$on('$ionicView.enter', function () {
      // 显示 tabs
      $rootScope.hideTabs = false;
    });
    var ref = new Wilddog(findItApp.saasServer);
    $scope.backUs = function() {
      $state.go('tab.profile');
    };
    $scope.aboutChat = function() {
      Information.rules(function(items) {
        var alertPopup = $ionicPopup.alert({
          title: '聊天室规定',
          template: items.data,
          okText: '关闭'
        });
        alertPopup.then(function(res) {
        });
      });
    };
    $scope.loginAnonymously = function(){
      $ionicLoading.show({
        templateUrl: 'templates/popover-template.html',
        scope: $scope
      });
      ref.authAnonymously(authHandler);
    };

    $scope.register = function(){
      $state.go('tab.chat-reg');
    };

    $scope.signIn = function(user) {
      $ionicLoading.show({
        templateUrl: 'templates/popover-template.html',
        scope: $scope
      });
      ref.authWithPassword({
        email    : user.username,
        password : user.password
      }, authHandler);
      //ref.onAuth(authDataCallback);
      //$state.go('tab.chat-home');
    };

    // 创建一个回调来处理终端用户认证的结果
    function authHandler(error, authData){
      $ionicLoading.hide();
      if (error) {
        console.log("Login Failed:", error);
        $ionicLoading.show({ template: "密码不正确，如果没注册过返回注册为会员", noBackdrop: true, duration: 1500 });
      } else {
        console.log("Authenticated successfully with payload:", authData);
        $state.go('tab.chat-home');
      }
    }
  })
  .controller('ChatHomeCtrl',['$scope','$ionicPlatform','$ionicHistory','$state','$ionicLoading','$rootScope','$ionicScrollDelegate','$timeout','ss','$ionicPopup','Private','$cacheFactory',function($scope,$ionicPlatform,$ionicHistory,$state,$ionicLoading,$rootScope,$ionicScrollDelegate,$timeout,ss,$ionicPopup,Private, $cacheFactory){
    $scope.closeLoader = function() {
      $ionicLoading.hide();
    };

    $scope.loading = true;
    var firstrun = true;
    var ipAddr;
    var viewScroll = $ionicScrollDelegate.$getByHandle('messageDetailsScroll');
    window.addEventListener("native.keyboardshow", function(){
      viewScroll.scrollBottom();
    });
    $scope.msgDetails = [];
    //$scope.myURL = $sce.trustAsResourceUrl('http://58boy.com');
    var ref = new Wilddog(findItApp.saasServer);
    ref.onAuth(authDataCallback);
    $scope.params = {
      atUserIds:"",
      atNicknames:"",
      sendContent : ""
    };
    function authDataCallback(authData) {
      ipAddr = ss.get("myIp");
      if (ipAddr == undefined ){
        ipAddr = "0.0.0.0";
      }
      var cityAddr = $rootScope.city == undefined ? "火星" : $rootScope.city;
      if (authData) {
        console.log("User " + authData.uid + " is logged in with " + authData.provider);
        $scope.userId = authData.uid;
        if(authData.provider == "anonymous"){ //匿名登录
          $scope.title = "场所畅聊(匿名)"

          $scope.nickname = "匿名"+ authData.uid.substr(authData.uid.length-3);
          $scope.thumb = "";
          findItApp.yourMutedOrNot(ipAddr,cityAddr, function (exists){
            $scope.isMuted = exists;
          });
          findItApp.isAllMuted(function (exists){
            $scope.isAllMuted = exists;
          });
        } else { //正常登陆
          $scope.title = "场所畅聊(会员)"
          $scope.isAllMuted = false;
          var key = authData.uid.replace("simplelogin:","");
          console.log(key);
          var ref2 = new Wilddog(findItApp.saasServer + "user/" + key);
          ref2.on("value", function(snapshot,error) {
            if (error == null) {
              $scope.nickname = snapshot.val().name;
              $scope.isMuted = snapshot.val().ismuted;
              $scope.thumb = findItApp.thumbConvert(snapshot.val().thumb);
            }
          });
          ref2.update({
            "logtime": findItApp.getTime(new Date())
          });

          //如果会员的封杀权限为false，再需判断一下
          if (!$scope.isMuted){
            findItApp.yourMutedOrNot(ipAddr,cityAddr, function (exists){
              $scope.isMuted = exists;
            });
          }
        }
        $scope.$on("$ionicView.beforeEnter", function() {
          //获取最近的12条聊天记录
          var ref = new Wilddog(findItApp.saasServer + "chat");
          ref.orderByKey().limitToLast(chatNumber).on("value", function(snapshot) {
            $scope.msgDetails = findItApp.getChatContent(snapshot.val(),$rootScope.lat,$rootScope.lng);
            //if(firstrun){
            //  var data = [];
            //  data.timestamp = 0 ;
            //  data.userId = $scope.userId;
            //  data.sendContent = "请文明聊天，禁止一切反动、黄色、辱骂和广告信息，违者将被封号！谢谢您的合作。";
            //  data.thumb = $scope.thumb;
            //  $scope.msgDetails.push(data);
            //  firstrun = false;
            //}
            //console.log($scope.msgDetails);
            $rootScope.hasNewTalk = true ;
            if(!$scope.$$phase) {
              $scope.$digest();
            }
            $scope.loading = false;
            $timeout(function() {
              viewScroll.scrollBottom();
            }, 0);
          });
          //获取最近12条记录结束
        });
        //$ionicLoading.show({ template: "登录成功!", noBackdrop: true, duration: 1500 });
      } else {
        console.log("User is logged out");
        $ionicLoading.show({ template: "聊天室需重新登录!", noBackdrop: true, duration: 800 });
        $state.go('tab.chat-log');
      }
    };
    $scope.sendPosition = function(){
      if ($scope.nickname == undefined){
        $ionicLoading.show({ template: "您按的太快了，稍等一下再操作!", noBackdrop: true, duration: 1500 });
      } else {
        //var queryStr = $scope.userId+','+ $scope.nickname + ","+$rootScope.lat+','+$rootScope.lng + ',' + findItApp.encode($scope.thumb);
        var user_cache = $cacheFactory("position_cache");  //声明一个user_cache缓存对象
        user_cache.put("uid",$scope.userId);
        user_cache.put("nickname",$scope.nickname);
        user_cache.put("latitude",$rootScope.lat);
        user_cache.put("longitude",$rootScope.lng);
        user_cache.put("thumb",$scope.thumb);
        $state.go("tab.chat-position");
        //window.location.href='#/tab/chat-position/'+ queryStr;
      }
    };
    $scope.checkPosition = function(lat,lng,addr){
      window.location.href='#/tab/chat-checkpos/'+ lat + ',' + lng+ ',' + addr;
    };
    $scope.atSomebody = function(userId, nickname){
      $scope.params.sendContent  += " @" + nickname + " ";
      $scope.params.atUserIds += userId + ",";
      $scope.params.atNicknames += nickname + ",";
    };
    $scope.doRefresh = function(){
      var ref = new Wilddog(findItApp.saasServer + "chat");
      console.log("chat number so far: " + $scope.msgDetails.length);
      ref.orderByKey().limitToLast($scope.msgDetails.length + chatNumber).on("value", function(snapshot) {
        $scope.msgDetails = findItApp.getChatContent(snapshot.val(),$rootScope.lat,$rootScope.lng);
        if(!$scope.$$phase) {
          $scope.$digest();
        }
      });
      $scope.$broadcast('scroll.refreshComplete');
    };
    $scope.leaveRoom = function(){
      $rootScope.hasNewTalk = false ;
      $state.go('tab.finding');
    };
    $scope.signOut = function(){
      var confirmPopup = $ionicPopup.confirm({
        title: '确认注销',
        template: "您确认要注销账户吗？",
        okText: '注销',
        cancelText: '取消'
      });
      confirmPopup.then(function (close) {
        if (close) {
          //退出代码
          ref.unauth();
          $rootScope.hasNewTalk = false ;
          $state.go('tab.chat-log');
        }
      });
    };
    $scope.sendMessage = function(sendContent,atUserIds, atNicknames) {
      if (findItApp.hasBadWords(sendContent,$rootScope.badwords)) {
        $ionicLoading.show({ template: "发言中有不雅及广告词汇，请纠正后再发。", noBackdrop: false, duration: 1000 });
        return ;
      }
      $ionicLoading.show({
        templateUrl: 'templates/popover-template.html',
        scope: $scope
      });
      var realAtUserIds = findItApp.extractUsers(sendContent,atUserIds, atNicknames);
      Private.timestamp(function (params) {
        //插入数据格式: timestamp:userId|nickname|type|message|lng|lat|thumb|ipAddr
        console.log(params.data);
        $scope.timeStamp = params.data;

        if ($rootScope.lng == undefined || $rootScope.lat == undefined) {
          $rootScope.lng = 0;
          $rootScope.lat = 0;
        }
        var ref3 = new Wilddog(findItApp.saasServer + "chat/" + $scope.timeStamp);
        ref3.set($scope.userId + "|" + $scope.nickname + "|1|" + sendContent + "|" + $rootScope.lat + "|" + $rootScope.lng + "|" + $scope.thumb + "|" + realAtUserIds + "|" + ipAddr);
        $scope.params.sendContent = "";
        $scope.params.atUserIds = "";
        $scope.params.atNicknames = "";
        //var data = [];
        //data.timestamp = findItApp.getLocalDate($scope.timeStamp);
        //data.userId = $scope.userId;
        //data.nickname = $scope.nickname;
        //data.sendContent = sendContent;
        //data.thumb = $scope.thumb;
        ////往屏幕上写字
        //$scope.msgDetails.push(data);
        $ionicLoading.hide();
      });
    };
  }])
  .controller('ChatRegCtrl',function($scope,$ionicLoading,$rootScope,$state,ls,ss,Private){
    $scope.closeLoader = function() {
      $ionicLoading.hide();
    };
    $scope.user = {
      username: "",
      password:"",
      cellphone:"",
      nickname:""
    };
    //当页面返回主页面时，需要再次显示tabs，则需要在该控制器中加上(主要是解决android上tabs还是隐藏的问题)：
    $scope.$on('$ionicView.enter', function () {
      // 显示 tabs
      $rootScope.hideTabs = false;
    });
    $scope.nickname = ls.get("myNickName")==undefined?"":ls.get("myNickName");
    $scope.signIn = function(){
      $state.go('tab.chat-log');
    };

    function checkUserRegister(user){
      if(user.username == undefined || user.username == ""){
        $ionicLoading.show({ template: "您的邮箱格式不对，请检查...", noBackdrop: true, duration: 2000 });
        return false;
      }
      if(user.cellphone == undefined || user.cellphone == ""){
        $ionicLoading.show({ template: "您的手机号码位数或格式不对，请检查...", noBackdrop: true, duration: 2000 });
        return false;
      }
      if(user.password == undefined || user.password == ""){
        $ionicLoading.show({ template: "您的密码应该保持5-20位，请检查...", noBackdrop: true, duration: 2000 });
        return false;
      }
      if(user.nickname != undefined && user.nickname != ""){
        var isMatch = user.nickname.match(/^[0-9a-zA-Z\u4e00-\u9fa5_]{2,15}$/);
        if (isMatch == null) {
          $ionicLoading.show({ template: "您的昵称应该保持2-15位，且只能为中文、字母、数字和下划线，请检查...", noBackdrop: true, duration: 2000 });
          user.nickname = $scope.nickname;
          return false;
        }
      }
      console.log(user);
      return true;
    }
    $scope.register = function(user) {
      if(!checkUserRegister(user)) {
        return;
      }
      if(user.nickname == undefined || user.nickname == ""){
        user.nickname = $scope.nickname;
      }

      $ionicLoading.show({
        templateUrl: 'templates/popover-template.html',
        scope: $scope
      });
      //现在终端用户认证表中建立用户和密码
      var ref = new Wilddog(findItApp.saasServer);
      ref.createUser({email: user.username, password: user.password},
        function (err, data) {
          if (err != null) {
            $ionicLoading.show({ template: "注册失败，邮箱已经被注册过...", noBackdrop: true, duration: 2000 });
            return;
          } else {
            //然后再插入user的数据表中
            ref.authWithPassword({
              email    : user.username,
              password : user.password
            }, authHandler);
          };

          // 创建一个回调来处理终端用户认证的结果
          function authHandler(error, authData) {
            if (error) {
              console.log("系统繁忙...", error);
            } else {
              console.log("Authenticated successfully with payload:", authData);
              //登录成功
              var uid = authData.uid.replace("simplelogin:","");
              var nickname = user.nickname==''?$scope.nickname:user.nickname;
              var city = $rootScope.city == undefined ? "火星" : $rootScope.city;
              var ref = new Wilddog(findItApp.saasServer + "user/" + uid);
              ref.set({
                "name":nickname,
                "city": city,
                "phone":user.cellphone,
                "thumb":$scope.nickname==""?"":"http://app.58boy.com/userthumb/" + findItApp.getIndexFromNick(user.nickname) +".png",
                "ismuted":false,
                "spotlike":""
              });
              //发送祝贺信息到公屏
              Private.timestamp(function (params) {
                //插入数据格式: timestamp:userId|nickname|type|message|lng|lat|thumb|ipAddr
                if ($rootScope.lng == undefined || $rootScope.lat == undefined) {
                  $rootScope.lng = 0;
                  $rootScope.lat = 0;
                }
                console.log(params.data);
                var ref = new Wilddog(findItApp.saasServer + "chat/" + params.data);
                ref.set(uid + "|" + nickname + "|9|我来自"+city+"，欢迎与我共同探讨同志场所的经历和感受，初来乍到，多多包涵。|"+$rootScope.lat+"|" +$rootScope.lng+ "||" + ss.get("myIp"));
                $state.go('tab.chat-home');
              });
            }
            $ionicLoading.hide();
          }
        });
    };
  })
  .controller('ChatPosCtrl',function($scope,$stateParams,Private,$state,$cacheFactory,ss){
    $scope.myform= {
      position: "",
      address:"",
      sendBtn: true
    };

    var ipAddr = ss.get("myIp");
    if (ipAddr == undefined ){
      ipAddr = "0.0.0.0";
    }
    var user_cache = $cacheFactory.get("position_cache");
    var uid = user_cache.get("uid");
    var nickname = user_cache.get("nickname");
    $scope.latitude = user_cache.get("latitude");
    $scope.longitude = user_cache.get("longitude");
    var thumb = user_cache.get("thumb");
    user_cache.destroy();
    console.log(uid + "," + nickname + "," + $scope.latitude + "," + $scope.longitude + "," + thumb);

    //var userInfo = $stateParams.userInfo;
    //var uid = userInfo.split(',')[0];
    //var nickname = userInfo.split(',')[1];
    //$scope.latitude = userInfo.split(',')[2];
    //$scope.longitude = userInfo.split(',')[3];
    //var thumb = findItApp.decode(userInfo.split(',')[4]);

    $scope.sendPosition = function(position, address) {
      Private.timestamp(function (params) {
        //插入数据格式: timestamp:userId|nickname|type|message|lng|lat|thumb|ipaddr
        console.log(params.data);
        var ref4 = new Wilddog(findItApp.saasServer + "chat/" + params.data);
        ref4.set(uid + "|" + nickname + "|2|" + address + "|" + position.split(',')[0] + "|" + position.split(',')[1] + "|" + thumb + "|" + ipAddr);
        $state.go('tab.chat-home');
      });
    };
  })
  .controller('ChatChkPosCtrl',function($scope,$stateParams){
    var posInfo = $stateParams.posInfo;
    $scope.latitude = posInfo.split(',')[0];
    $scope.longitude = posInfo.split(',')[1];
    $scope.address = posInfo.split(',')[2];
  })
  .controller('SettingContactCtrl',function($scope){
    $scope.bigImage = false;
    $scope.openWebsite = function(){
      window.open('http://58boy.com', '_system', 'location=yes');
    }
    $scope.openQQ = function(qunhao){
      window.open('mqqapi://card/show_pslcard?src_type=internal&version=1&uin=' + qunhao + '&card_type=group&source=qrcode', '_system', 'location=yes');
    }

    $scope.showBigImage = function () {  
      $scope.bigImage = true; 
    }

    $scope.hideBigImage = function () {
        $scope.bigImage = false;
    }
  });
